package MPI ;

public class Cart extends Comm {
  public Cart(Comm old, int ndims, int[] dims, 
    boolean[] periods, boolean reorder) 
  { handle = GetCart(old, ndims, dims, periods, reorder);}

  public native void Get(int maxdims, int[] dims, 
    boolean[] periods, int[] coords);
  public native int Rank(int[] coords);
  public native void Coords(int rank, int maxdims, int[] coords);
  public native void Shift(int direction, int disp, 
    int[] source, int[] dest);

  private Cart(long _handle) { handle = _handle;}  
  private native long GetCart(Comm old, int ndims, int[] dims, 
    boolean[] periods, boolean reorder);
}

