#include <mpi.h>
#include "MPI_Op.h"

#define REF(x) (*(void**)&(x))

int64_t MPI_Op_GetOp(struct HMPI_Op *this, long Type) {
  int64_t result;
  static MPI_Op Ops[] = { MPI_OP_NULL, MPI_MAX, MPI_MIN, MPI_SUM,
    MPI_PROD, MPI_LAND, MPI_BAND, MPI_LOR, MPI_BOR, MPI_LXOR,
    MPI_BXOR, MPI_MINLOC, MPI_MAXLOC};
  REF(result) = Ops[Type];
  return result;
}

